pro S8_Save_PSF_stars_region_file, Event, region_path, rad_PSF, x_psf, y_psf, n_xy_psf, COLOR = color, debug
	;
	;	creates and saves region file of active PSF stars
	;	- if no color is set, then
	;	 - each zone gets a colored circle
	;	 - colors cycle between PSF zones
	;
	zones = SIZE(n_xy_psf)
	nxg = zones[1]
	nyg = zones[2]
	;
	if(N_ELEMENTS(debug) eq 0) then debug = 0
	if(N_ELEMENTS(color) eq 0) then do_color = 1 else do_color = 0
	;
	openw, lu_reg, region_path, /GET_LUN
	;
	for ix = 0, nxg-1 do begin
			;
		for iy = 0, nxg-1 do begin
			;
			if(do_color eq 1) then begin
				num = iy + ix * nxg
				;
				num = num MOD 6
				case num of
					0:	color = 'red'
					1:	color = 'blue'
					2:  color = 'green'
					3:  color = 'magenta'
					4:  color = 'yellow'
					5:  color = 'cyan'
				endcase
			endif
			;
			n = n_xy_psf[ix,iy]
			;
			if(debug gt 1) then print, "for region [ix,iy] = ",ix,iy," number of PSF stars = ",n
			;
			for i = 0, n-1 do begin
				if(debug gt 1) then print, "  for star ",i," x,y = ", x_psf[ix,iy,i]+1, y_psf[ix,iy,i]+1
				printf, lu_reg, FORMAT='("circle ",f8.1,1x,f8.1,1x,f4.1,"# color = ",a)',x_psf[ix,iy,i]+1,$
											y_psf[ix,iy,i]+1,rad_PSF, color
			endfor
		endfor
	endfor
	FREE_LUN, lu_reg
end