pro ap_apply_inst_correction_sendimg, Event, xyarr, u_in, q_in, u_out, q_out, status
;
;	applies instrumental correction to p and pa
;
;	fetches all correction constants and images from where they were put on heap
;
;	07/09/07 -- origional ap
;	07/27/07 -- modified to use p and pa images
;	09/19/07 -- corrects a single star, returning pol and pa
;	12/31/08 -- takes pa and pa images as imputs
;
;	20100506 - DPC - added heap lookup, added Event processing - rewrote to be UQ corrected, not P, PA
;
;------------------------------------------------------------------------------------------
;
;	connect to heap variables and images
;
WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
w_ptr = PTR_struct.PTR_wid_id
;
u_inst_ptr = (*w_ptr).S9_u_inst_ptr
q_inst_ptr = (*w_ptr).S9_q_inst_ptr
sig_u_ptr  = (*w_ptr).S9_u_sig_inst_ptr
sig_q_ptr  = (*w_ptr).S9_q_sig_inst_ptr
;
dtor=!pi / 180.
;
;	fetch P_inst contants directly
;
P_efficiency 	= (*(*w_ptr).S9_P_inst_values_ptr).pol_efficiency
sig_P_efficiency 	= (*(*w_ptr).S9_P_inst_values_ptr).s_pol_effic
datestamp 		= (*(*w_ptr).S9_P_inst_values_ptr).date_stamp
;
;	pointer to the right year's offset angle - assumed set in calling program or earlier
;
jpol			= (*(*w_ptr).S9_P_inst_values_ptr).this_pol_off_ind
;
;	get the right offset angle
;
P_offset     		= (*(*w_ptr).S9_P_inst_values_ptr).pol_off_angle[jpol] * dtor
sig_P_offset   	= (*(*w_ptr).S9_P_inst_values_ptr).s_pol_off_angle[jpol] * dtor
;
;print, "P - efficiency, offset = ",P_efficiency, P_offset
;
;stop
;
;-------------------------------------------------------------------------
;
;	unpack star raw values
;
raw_u		=	100.0 * u_in[0] ;* (-1.0)	; -1 to flip U_raw
raw_q		=	100.0 * q_in[0]
sig_raw_u 	= 	100.0 * u_in[1]
sig_raw_q 	= 	100.0 * q_in[1]
;
;	star's mean location on the array
;
starx = xyarr[0]
stary = xyarr[1]
;
;	instrumental correction terms at that location
;
this_u_inst 	= (*u_inst_ptr)[starx, stary]
this_q_inst 	= (*q_inst_ptr)[starx, stary]
this_sig_u_inst = (*sig_u_ptr)[starx, stary]
this_sig_q_inst = (*sig_q_ptr)[starx, stary]
;
;	projection cos and sin for offset angle and efficiency
;
c		=	cos(P_offset * 2.0) / P_efficiency
s		=	sin(P_offset * 2.0) / P_efficiency
sig_c 	= 	(1./P_efficiency) * sqrt( (sig_P_efficiency^2)*(sin(P_offset * 2.0))^2 + $
				4.0 * sig_P_offset^2 * (cos(P_offset * 2.0))^2 )
sig_s 	= 	(1./P_efficiency) * sqrt( (sig_P_efficiency^2)*(cos(P_offset * 2.0))^2 + $
				4.0 * sig_P_offset^2 * (sin(P_offset * 2.0))^2 )
;
;	perform the correction of the star's raw U, Q to the final U, Q
;
dQ 		= raw_q - this_q_inst
dU 		= raw_u - this_u_inst
sig_dU 	= sqrt(this_sig_u_inst^2 + sig_raw_u^2)
sig_dQ 	= sqrt(this_sig_q_inst^2 + sig_raw_q^2)
;
q_cor	= dQ * c  -  dU * s
u_cor	= dU * c  +  dQ * s
;
;u_cor   *= -1.0				; to make sky-true
;
;	compute uncertainties
;
sig_q_cor = sqrt( (c * sig_dQ)^2 + (dQ * sig_c)^2 + (s * sig_dU)^2 + (dU * sig_s)^2 )
sig_u_cor = sqrt( (c * sig_du)^2 + (dU * sig_c)^2 + (s * sig_dQ)^2 + (dQ * sig_s)^2 )
;
u_out	=	0.01 * [u_cor,sig_u_cor]
q_out	=	0.01 * [q_cor,sig_q_cor]
;
status = 0
;
end
