pro ap_correction_factors, Event, group_name, group_summary_file
	;
	;  10/30/2008 -- origional code -- ap
	;  12/3/2008 -- sorts by julian date,
	;               keeps only ones place and decimil of julian date -- afp
	;
	;	DPC	20081221	imported into MSP_PPOL
	;---------------------------------------------------
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	;
	plot_wid = (*w_ptr).S6A_plot_window_wid
	;
	device,decompose=0
	color_names = ["black", "white", "red", "orange", "yellow", "green", "blue", "violet", "gray"]
	color_values= [10,11,12,13,14,15,16,17,18,19]
	device, decomposed=0
	loadct, 13, /silent
	tvlct,        [0,        255,     255,     255,    255,        50,      0,       148,    190], $
	              [0,        255,       0,     165,    255,       205,      0,         0,    190], $
	              [0,        255,       0,       0,      0,        50,    255,       211,    190], 10
	;
	;---------------------------------------------------------------------------------
	;
	;	read in summary list
	;
	;file_in = dialog_pickfile(Title="Select post-psf match list (from dan's program)",path="E:\Pinnick\")
	file_in = group_summary_file
	;
	print_text, Event, "Reading match summary file "+FILE_BASENAME(file_in)
	;
	;	reads in list from file
	;
	openr, in_lun, file_in, /GET_LUN
	info_list = strarr(200)
	num=0
	line_in=''
	while (~EOF(in_lun)) do begin
	    readf, in_lun, line_in, format='(a)'
	    info_list[num]=line_in
		num++
	endwhile
	FREE_LUN, in_lun
	info_in_array=info_list[0:num-1]
	;
	foo_info = {	file_num:				0L, $
					file_name:				'', $
					julian_date:		 0.0D0, $
					hwp:				   0.0, $
					n_stars:				0L, $
					del_mag:			 0.0d0, $
					mag_uncer:			 0.0d0, $
					x_offset:			 0.0d0, $		; X offset to add to this image to match reference
					y_offset:			 0.0d0, $
					ff_num:					0L  $
				}
	;
	cf_data=replicate(foo_info,num)
	;
	;	put each line into the structure
	;
	for i=0, num-1 do begin
		next_line=info_in_array[i]
		next_line_split=strsplit(next_line,' ',/regex,/extract)
		n_parts = N_ELEMENTS(next_line_split)
		;
		cf_data[i].file_num=fix(next_line_split[0])
		;
		;	windows allows blanks in filenames and directories. have to
		;	locate that and patch it here
		;
		;	look forward in the parts until "phot.dat" is found - this is the
		;		last part making up the filename
		;
		last_name_part = 1
		for ip = 1, n_parts-1 do begin
			test = STRPOS(next_line_split[ip], "phot.dat")
			if(test ne -1) then begin
				last_name_part = ip
				goto, out_loop
			endif
		endfor
		out_loop:
		;
		;	reconstruct the name
		;
		name = ''
		for ip = 1, last_name_part do begin
			name = name + next_line_split[ip]
		endfor
		;
		cf_data[i].file_name=name
		;
		;	all others are offset from the last name part
		;
		lnp = last_name_part - 1
		;
		cf_data[i].julian_date=double(next_line_split[lnp+2])-2000000.0d0
		cf_data[i].hwp=float(next_line_split[lnp+3])
		cf_data[i].n_stars=fix(next_line_split[lnp+4])
		cf_data[i].del_mag=double(next_line_split[lnp+5])
		cf_data[i].mag_uncer=float(next_line_split[lnp+6])
		;
		cf_data[i].x_offset = double(next_line_split[lnp+9])
		cf_data[i].y_offset = double(next_line_split[lnp+10])
		;
		current_hwp=float(next_line_split[lnp+3])
		;

		case current_hwp of
			0: cf_data[i].ff_num=0
			22.3: cf_data[i].ff_num=45
			45.2: cf_data[i].ff_num=90
			67.5: cf_data[i].ff_num=135
			89.8: cf_data[i].ff_num=0
			112.7: cf_data[i].ff_num=45
			135.0: cf_data[i].ff_num=90
			157.3: cf_data[i].ff_num=135
			180.2: cf_data[i].ff_num=0
			202.5: cf_data[i].ff_num=45
			224.8: cf_data[i].ff_num=90
			247.7: cf_data[i].ff_num=135
			270.0: cf_data[i].ff_num=0
			292.3: cf_data[i].ff_num=45
			315.2: cf_data[i].ff_num=90
			337.5: cf_data[i].ff_num=135
		endcase
	endfor
	;
	;cf_data=cf_data(0:num-1)		; not needed, due to way created
	;
	;	sort data by julian date
	;
	j_date_order=sort(cf_data.julian_date)
	cf_data=cf_data(j_date_order)
	;
	;	remove most of the julian date to ease calculations
	;
	julian_extra = floor(cf_data[0].julian_date*0.1) * 10
	cf_data.julian_date = cf_data.julian_date - double(julian_extra[0])
	;
	mags       = cf_data.del_mag
	mags_uncer = cf_data.mag_uncer
	;
	;	convert to flux units, for a convenient reference point
	;
	fluxes = 10.0d0^(-0.40d0 * mags)
	;
	;		flux uncertainty
	;
	;dm_df = (mags)*(-1.0d0)*(ALOG(10))/2.5
	;
	fluxerr = mags_uncer * fluxes * (1./1.086)
	;
	;	plot fluxes
	;
	WIDGET_CONTROL, plot_wid, GET_VALUE=win_no
	wset, win_no
	erase
	ymax = MAX(fluxes)
	ymin = MIN(fluxes)
	max_deviation = (ymax-1.) > (1.-ymin)
	n_deci = ROUND(max_deviation * 20.0)
	;
	yrange = [1-0.05*n_deci,1+0.05*n_deci]
	dy = yrange[1]-yrange[0]
	;
	xrange = [MIN(cf_data.julian_date), MAX(cf_data.julian_date)]
	dx = xrange[1] - xrange[0]
	xrange[0] = xrange[0]-0.02*dx
	xrange[1] = xrange[1]+0.02*dx
	dx = xrange[1] - xrange[0]
	plot, cf_data.julian_date, fluxes, yrange=yrange, xrange=xrange, xstyle=1 , ystyle=1, $
			xtitle='Time offset from first image [days]', ytitle='Scale Factor',$
			color=10, background=18, /NODATA
	oplot, cf_data.julian_date, fluxes, color=17
	x = xrange[0]+0.05*dx
	y = yrange[0]+0.1*dy
	XYOuts, x, y, "Data", color=17, charsize=1.5
	;
	; 	add error bars
	;
	yerrx = dblarr(num)
	yerry1 = dblarr(num)
	yerry2 = dblarr(num)
	for i=0,num-1 do begin
		;plot yerror bar
		yerrx=cf_data[i].julian_date
		yerry1=(fluxes[i]-fluxerr[i]) > yrange[0]
		yerry2=(fluxes[i]+fluxerr[i]) < yrange[1]
		plots,[yerrx,yerrx],[yerry1,yerry2],color=17
	endfor
	;ap_plot_errors_color,cf_data.julian_date,fluxes,foobar_julian,fluxerr,240
	;
	;		determine the correction factors to fit and remove, so as to uncover
	;			any remaining sky variations
	;
	;		in order, they are:
	;					1. secular variation
	;					2. intensity variation (ie, I_u, I_q must match for every quad of obs)
	;					3. field polarization
	;					4. sky variation
	;
	;		the final scale factor to report will be the product of
	;					1 * 2 * 4
	;
	;			but, the field polarization will *not* be removed.
	;
	;-------------  part 1 - secular variation --------------------
	;
	;let's do a LAD fit
	;;		LADfit = least absolute deviation fit
	;; 			y = a +bx
	;;			Result = LADFIT( X, Y [, ABSDEV=variable] [, /DOUBLE] )
	;;			The result is a two-element vector containing the model parameters, A and B.
	;
	ladfit_vals=dblarr(3)
	;
	;	use julian time for x vals
	;
	result = ladfit (cf_data.julian_date,fluxes,absdev=dev,/double)
	;
	ladfit_vals[0:1] = result
	ladfit_vals[2] = dev
	;
	;	secular correction factor = a + bx
	;
	secular_cf = ladfit_vals[0] + ladfit_vals[1] * cf_data.julian_date
	;
	;plot,cf_data.julian_date,fluxes,psym=-1,color=0,background=255,yrange=[.9,1.1],ystyle=1
	;
	oplot,cf_data.julian_date, secular_cf, psym=-3, color=16
	x = xrange[0]+0.25*dx
	y = yrange[0]+0.1*dy
	XYOuts, x, y, "Secular CF", color=16, charsize=1.5
	;
	;	apply correction
	;
	secular_corrected_fluxes = fluxes / secular_cf
	;
	;	PLOT
	;
	;oplot,cf_data.julian_date, secular_corrected_fluxes ,psym=-1,color=13
	;
	;------------- Part 2 - intensity corrections ---------------------------
	;
	foo = cf_data.ff_num
	;
	ind_0   = where(foo eq 0)
	ind_45  = where(foo eq 45)

	ind_90  = where(foo eq 90)
	ind_135 = where(foo eq 135)
	;
	ff_mfm = dblarr(4,2)
	;
	for x = 0, 3 do begin
		case x of
			0: current_ind = ind_0
			1: current_ind = ind_45
			2: current_ind = ind_90
			3: current_ind = ind_135
		endcase
		;
		result = median_filtered_mean(secular_corrected_fluxes[current_ind])
		ff_mfm[x,*] = result
		ff_mfm[x,1] = ff_mfm[x,1] / sqrt(n_elements(current_ind)-1.)	; April - you missed the sqrt
	endfor
	;
	;intensity correction factor insures overall intensity is not incremented or decremented
	;
	;	april's original set
	;	intensity_q_cf	=	(ff_mfm(0,0)+ff_mfm(1,0))/2.
	;	intensity_u_cf	=	(ff_mfm(2,0)+ff_mfm(3,0))/2.
	;
	;	my set
	;
	intensity_q_cf	=	(ff_mfm[0,0] + ff_mfm[2,0]) / 2.
	intensity_u_cf	=	(ff_mfm[1,0] + ff_mfm[3,0]) / 2.
	;
	intensity_cf = dblarr(num)
	;
	intensity_cf[ind_0]  = intensity_q_cf
	intensity_cf[ind_45] = intensity_u_cf
	intensity_cf[ind_90] = intensity_q_cf
	intensity_cf[ind_135]= intensity_u_cf
	;
	;	correct for intensity before finding field polarization
	;
	secular_intensity_corrected_fluxes = secular_corrected_fluxes / intensity_cf
	;
	oplot,cf_data.julian_date,intensity_cf,color=12
	x = xrange[0]+0.45*dx
	y = yrange[0]+0.1*dy
	XYOuts, x, y, "UQInten CF", color=12, charsize=1.5
	;
	;---------------------- Part 3 - Field polarization
	;
	for x = 0, 3 do begin
		case x of
			0: current_ind = ind_0
			1: current_ind = ind_45
			2: current_ind = ind_90
			3: current_ind = ind_135
		endcase
		result = median_filtered_mean(secular_intensity_corrected_fluxes[current_ind])
		ff_mfm[x,*] = result
		ff_mfm[x,1] = ff_mfm[x,1] / sqrt(n_elements(current_ind)-1.)	; April - you missed the sqrt
	endfor
	;
	;	mfm is pol correction factor
	;
	pol_cf = dblarr(num)
	;
	pol_cf[ind_0]   = ff_mfm[0,0]
	pol_cf[ind_45]  = ff_mfm[1,0]		; changed 90->45
	pol_cf[ind_90]  = ff_mfm[2,0]		; changed 45-> 90
	pol_cf[ind_135] = ff_mfm[3,0]
	;
	;	for fun, calculate field polarization
	;
	field_q = (ff_mfm(0,0)-ff_mfm(2,0))/(ff_mfm(0,0)+ff_mfm(2,0))
	field_u = (ff_mfm(1,0)-ff_mfm(3,0))/(ff_mfm(1,0)+ff_mfm(3,0))
	;
	field_q_sig = sqrt(  ((ff_mfm(0,0))^2*(ff_mfm(2,1))^2+(ff_mfm(2,0))^2*(ff_mfm(0,1))^2)  $
							*  4./( (ff_mfm(0,0)+ff_mfm(2,0))^4)  )
	field_u_sig = sqrt(  ((ff_mfm(1,0))^2*(ff_mfm(3,1))^2+(ff_mfm(3,0))^2*(ff_mfm(1,1))^2)  $
							*  4./( (ff_mfm(1,0)+ff_mfm(3,0))^4)  )
	;
	ap_uq2polpa,[field_u,field_u_sig],[field_q,field_q_sig],pol,pa
	print_text, Event,"Field polarization = "+STRING(pol[0]*100.0,pol[1]*100.0,format='(F8.2,"+/-",F6.2," percent")')
	;
	secular_intensity_pol_corrected_fluxes = secular_intensity_corrected_fluxes / pol_cf
	;
	;plot,cf_data.julian_date,fluxes,psym=-1,color=0,background=255,yrange=[.9,1.1],ystyle=1
	;
	oplot,cf_data.julian_date,pol_cf,psym=-1,color=14
	x = xrange[0]+0.65*dx
	y = yrange[0]+0.1*dy
	XYOuts, x, y, "Pol CF", color=14, charsize=1.5
	;
	;---------------------- Part 4 - sky correction -----------------------
	;
	;	sky correction factor is the result - this is what remains after all
	;	other corrections have been factored in
	;
	sky_cf = secular_intensity_pol_corrected_fluxes
	;
	;	compute the power in the sky term
	;
	zz = median_filtered_mean(sky_cf)
	print_text, Event, "Sky correction power (rms, as %) = "+STRING(100.0*zz[1],format='(F12.3)')
	;
	oplot,cf_data.julian_date,sky_cf,psym=-1,color=13	; this is just pol
	x = xrange[0]+0.80*dx
	y = yrange[0]+0.1*dy
	XYOuts, x, y, "Sky CF", color=13, charsize=1.5
	;
	;-----------------------------------------------------------------------
	;
	;			compute final scale factor for each image
	;
	; 	the final correction factor is sky_cf * intensity_cf * secular_cf
	;			(ie, leave the field polarization intact)
	;
	final_correction_factor = sky_cf * intensity_cf * secular_cf
	;
	;oplot,cf_data.julian_date,fluxes/(final_correction_factor),psym=-1,color=10
	;
	multiplicative_cf = 1.0 / final_correction_factor
	;
	;	save correction factors in group named files in Scaling directory
	;
	dir = (*s_ptr).analysis_dir + 'S6_Scaling' + PATH_SEP()
	path_out = dir + replace_underscores(group_name) + '_group_scale_factors.dat'
	openw, lu_out, path_out, /GET_LUN
	;
	printf, lu_out, format='(";;Scaling factors (+ X, Y offsets) for images in ",a)',group_name
	for i = 0, num-1 do begin
		printf, lu_out, FILE_BASENAME(cf_data[i].file_name), cf_data[i].hwp, multiplicative_cf[i], $
						cf_data[i].x_offset, $
						cf_data[i].y_offset, format='(a,2x,f5.1,1x,F12.8,1x,f7.2,1x,f7.2)'
	endfor
	FREE_LUN, lu_out
	;
	print_text, Event,'Finished scaling group '+group_name
end