function display_image,image, window_number, MESSAGE=message, BIPOLAR=bipolar, XOFF=xoff, $
			YOFF=yoff
;
;   displays an image; leaving it up in designated window
;
;   bipolar switch centers mean in mid-color range - use
;   for differenced images to see up and down aspects
;
;   DPC   20060225  based on fastlook code
;		  20090626  added xoff, yoff
;
;
if(N_ELEMENTS(BIPOLAR) eq 0) then bipolar=0 else bipolar=1
if(N_ELEMENTS(MESSAGE) eq 0) then message=''
if(N_ELEMENTS(XOFF) eq 0) then x_off=0 else x_off = xoff
if(N_ELEMENTS(YOFF) eq 0) then y_off = 0 else y_off = yoff
device, decomposed=0
loadct, 13, /SILENT
tvlct, 0,0,0,0
tvlct, 255, 255, 0, 1
;
this_image = image
;
first_image_flag = 0
row0 = 0
row1 = 0
col0 = 0
col1 = 0
rowsize = row1 - row0 + 1
colsize = col1 - col0 + 1
;
path = ''
image_size = size(this_image)
row1 = image_size[2] - 1
col1 = image_size[1] - 1
rowsize = row1 - row0 + 1
colsize = col1 - col0 + 1
;print, "in display_image: Image format = ",colsize,' x ',rowsize
ind = WHERE(this_image eq -1.0e6,count)
if(count gt 0) then this_image[ind] = 0.0
small_image = fix_bad_pixels(this_image)
small_size = SIZE(small_image)
nxs = small_size[1]
nys = small_size[2]
;ind = where(small_image gt -3000 and small_image lt 100000)
small_image = REFORM(small_image,nxs * nys)
;ind = WHERE(small_image[*])
z = median_filtered_mean(small_image)
image_mean = z[0]
image_stddev = z[1]
;print, "in display_image: mean, stdev = ",image_mean, image_stddev
image_max = max(small_image)
image_min = min(small_image)
;print, "in display_image: min, max, mean, stdev = ",image_min, image_max, image_mean, image_stddev
if(bipolar eq 1) then begin
    range = 4.0
    offset = 127
endif else begin
    range = (240.-12.)*image_stddev/(image_max - image_mean)
    offset = 12
endelse
;
displ = byte(4)+bytscl(this_image,min=(image_mean - 2.0*image_stddev),max=image_max,top=250)
;
window, window_number, XSIZE=colsize, YSIZE=rowsize, Xpos = 300+x_off, Ypos = 100+y_off, title=message
tv, displ
;
return,z
end