pro get_cluster_QU_corrections, cluster, band, Qa, sQa, Ua, sUa, ier
;
;	look up the Q, U corrections to add to the values for this cluster to arrive
;	at the equivalent boresight instrumental Q, U obtained from the cluster means
;
;	DPC	20140217
;
;
a = {cl, band: '', name: '', Qa: 0.0d0, sQa: 0.0d0, Ua: 0.0d0, sUa: 0.0d0}
db = replicate(a, 14)
;
db[0] = {cl, 'H', 'M12',	0.2097,		0.1047,		-0.1646,	0.1325}
db[1] = {cl, 'H', 'M13',	0.0259,		0.0192,		0.0703,		0.0193}
db[2] = {cl, 'H', 'M15',	-0.0162,	0.0397,		0.1385,		0.0401}
db[3] = {cl, 'H', 'M2',		-0.0928,	0.0292,		-0.0268,	0.0299}
db[4] = {cl, 'H', 'M3',		-0.0425,	0.0127,		-0.0079,	0.0130}
db[5] = {cl, 'H', 'M30',	-0.0465,	0.0614,		0.1078,		0.0586}
db[6] = {cl, 'H', 'M5',		0.0239,		0.0117,		-0.0285,	0.0121}
db[7] = {cl, 'H', 'M71',	-0.2558,	0.0157,		0.0369,		0.0159}
db[8] = {cl, 'H', 'M92',	0.1202,		0.0661,		0.1286,		0.0665}
db[9] = {cl, 'H', 'NGC5466',0.0904,		0.0298,		0.0411,		0.0310}
;
db[10] = {cl, 'K', 'M15',	0.1801,		0.0587,		-0.1527,	0.0587}
db[11] = {cl, 'K', 'M2',	-0.1589,	0.0577,		-0.0513,	0.0567}
db[12] = {cl, 'K', 'M3',	-0.0057,	0.0325,		0.0230,		0.0335}
db[13] = {cl, 'K', 'M5',	0.0029,		0.0359,		0.0333,		0.0348}
;
ind = WHERE(db[*].band eq band and db[*].name eq cluster, nmatch)
if(nmatch eq 1) then begin
	j = ind[0]
	Qa = db[j].Qa
	sQa = db[j].sQa
	Ua = db[j].Ua
	sUa = db[j].sUa
	ier = 0
endif else begin
	if(nmatch gt 1) then ier = 2
	if(nmatch eq 0) then ier = -1
endelse
;
end
