function ppol_fetch_mass, Event, header, f17
;
;	DPC	20091211	added more mirror site calls to vizier call
;
;	20100518 - larger search radii
;	20100722 - added test for coadded image. if so, then use crval1,2 instead of telera, teledec
;
;--------------------------------------------------
;
if KEYWORD_SET(F17) then search = 4.0 else search = 14.0
;f5_search = 14.0
;f17_search = 4.0
;
;	test for presence of CD1_1 and/or MPP_NADD
;
CD1_1 = sxpar(header, 'CD1_1', COUNT=test1)
MPP_NADD = sxpar(header, 'MPP_NADD', COUNT=test2)
;
if(test1 gt 0 or test2 gt 0) then coadd = 1 else coadd = 0
;
;tel_ra = sxpar(header, 'TELRA')
;tel_dec = sxpar(header, 'TELDEC')

xsize = sxpar(header,'NAXIS1')
ysize = sxpar(header,'NAXIS2')
;crpix1 = sxpar(header,'CRPIX1')
crval1 = sxpar(header,'CRVAL1')
;crdelt1 = sxpar(header,'CRDELT1')
;crota1 = sxpar(header,'CROTA1')
;cfint1 = sxpar(header,'CFINT1')
;crpix2 = sxpar(header,'CRPIX2')
crval2 = sxpar(header,'CRVAL2')
;
;	don't forget to check epoch!
;
epoch = sxpar(header, "EQUINOX")
;
;	if mode is not coadd, then get rough coordinates from the
;	telescope ra and dec
;
if(coadd eq 0) then begin
	this_ra = 15.d*ten(double(strsplit(sxpar(header,'TELRA'),':',/EXTRACT))); telescope RA in degrees
	this_dec = ten(double(strsplit(sxpar(header,'TELDEC'),':',/EXTRACT))); telescope Dec in degrees
	;
	neg_yn = strpos(sxpar(header,'TELDEC'),'-') ne -1
	if(neg_yn eq 1) then this_dec = -1.0* abs(this_dec)			; strsplit drops the - sign for -00d
	;
	if(epoch ne 2000.0) then begin
		;
		;	must precess to J2000
		;
		precess, this_ra, this_dec, epoch, 2000
	endif
;
endif else begin
	this_ra = crval1
	this_dec = crval2
endelse
;
;this_mirror = ['CA', 'CfA', 'UK', 'Jp', 'CDS']		; CA having problems responding
;this_mirror = ['CfA', 'UK', 'Jp', 'CDS', 'CA']		; Jp earthquake 3/9/2011
this_mirror = ['CfA', 'UK', 'CDS', 'CA', 'Jp']

;
nloop = 0L
WHILE nloop lt 4320L do begin							; 1 day at 20 sec per try
	;
	vizier_flag = 0
	for imirror = 0, N_ELEMENTS(this_mirror)-1 do begin
	     if(vizier_flag eq 0) then begin
	  		info = mp_QueryVizier('2MASS-PSC', [this_ra,this_dec], [search*(xsize/1024.0),search*(ysize/1026.0)], $
	  		MIRROR=this_mirror[imirror], constraint='Qflg==AAA')
	  		test = size(info)
	  		if test[0] ne 0 then vizier_flag = 1
	     endif
	endfor
	;
	if(vizier_flag eq 0) then begin
	      	info = 99   ;No Vizier servers available
			;
			;	if no Vizier servers, wait 20s and retry
			;
			print, 'No Vizier Servers at ',SYSTIME(),' waiting 20s and retrying'
			wait, 20
			nloop++
	endif else goto, done
ENDWHILE
;
;help, info
;stop
;
done:
return,info

end
