pro reconnect_to_BDP_Directory, Event, image_path
;
;	got here because a seek for BDP data failed to
;	find the BDP file
;
;	allows user opportunity to point to a new BDP
;	directory to find the file
;
;	if that directory exists and the file is found,
;	then look through the group data base for similar
;	'old' paths and replace them with this 'new'
;	path and update the group save file
;
;	DPC	20130821	new routine
;
;
WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
w_ptr = PTR_struct.PTR_wid_id
s_ptr = PTR_struct.PTR_summary
g_ptr = PTR_struct.PTR_group
;
file_name = FILE_BASENAME(image_path)
old_dir_name = FILE_DIRNAME(image_path)
;
mes = ['BDP Directory '+old_dir_name+' not found.', 'Do you wish to select another?']
yn = DIALOG_MESSAGE(mes, /QUESTION)
;
if(STRUPCASE(STRTRIM(yn,2)) eq 'NO') then begin
	print_text, Event, 'PPOL Ending at user request'
	stop
endif
;
;	otherwise, select new directory
;
try_again:
new_dir = dialog_pickfile(Title='Select new/updated BDP directory',/directory)
;
new_path = new_dir + file_name
;
;	test for the file being there
;
test = FILE_INFO(new_path)
if(test.exists ne 1) then begin
	print_text, Event, 'File '+new_path+' not found '
	mes2 = DIALOG_MESSAGE('Select again?',/QUESTION)
	;
	if(STRUPCASE(STRTRIM(mes2)) eq 'YES') then goto, try_again
	;
	;	if not, stop
	;
	print_text, Event, 'PPOL Ending at user request'
	stop
endif
;
print_text, Event, 'Reconnected to BDP directory OK'
;
;	file was there, all ok
;
;	next, search all groups for the same 'old' directory,
;	replacing them with the 'new' directory, then
;	rewrite the group file
;
nfixed = 0L
;
n_groups = (*g_ptr).n_groups
for ig = 0, n_groups-1 do begin
	;
	;	number of images in this group
	;
	n_in_group = (*g_ptr).group_numbers[ig]
	;
	if(n_in_group ge 1) then begin
		;
		for igg = 0, n_in_group-1 do begin
			;
			;	get current path
			;
			this_path = FILE_DIRNAME((*g_ptr).group_images[ig,igg])
			;
			if(this_path eq old_dir_name) then begin
				this_file = FILE_BASENAME((*g_ptr).group_images[ig,igg])
				this_new_path = new_dir + this_file
				(*g_ptr).group_images[ig,igg] = this_new_path
				nfixed++
			endif
		endfor
	endif
endfor
;
;	if fixed any, report to user and save group file
;
if(nfixed gt 0) then begin
	print_text, Event, 'Fixed BDP directory names for '+STRING(nfixed,format='(i5)')+' images'
	;
	MSP_PPOL_Save_Group_File, Event
endif
;
;	reset this image's pathname and return
;
image_path = new_path
;
end
