pro S10_compute_uq_inst_images
;
;	reads POLCATS of uncorrected data to build model
;	images of Instrumental corrections for U & Q,
;	along with their uncertainty images
;
;	DPC	20100819
;
;
files_in = dialog_pickfile(Title="Select PHOTCAT files",/multiple_files)
n_files = N_ELEMENTS(files_in)
if(n_files eq 0) then stop
;
;	pass them to the UQ_inst calculator
;
result = s10_UQ_inst(files_in, UQ_struct)
;
;	result is a structure with four 1024x1024 images (U,sU,Q,sQ)
;
dir_out = dialog_pickfile(Title='Directory to save P_Inst images',/directory)
;
;	does this directory exist? If not, create it
;
test = FILE_INFO(dir_out)
if(test.exists ne 1 or test.directory ne 1) then FILE_MKDIR, dir_out
;
path_u = dir_out + 'u_inst.fits'
path_su = dir_out + 'u_sig_inst.fits'
path_q = dir_out + 'q_inst.fits'
path_sq = dir_out + 'q_sig_inst.fits'
path_p = dir_out + 'p_inst.fits'
path_sp = dir_out + 'p_sig_inst.fits'
path_n = dir_out + 'nstars_used_per_pixel.fits'
path_reg = dir_out + 'stars_used.reg'
;
writefits, path_u, result.u_image
writefits, path_su, result.su_image
writefits, path_q, result.q_image
writefits, path_sq, result.sq_image
writefits, path_p, result.p_image
writefits, path_sp, result.sp_image
writefits, path_n, result.n_image
openw, lu_stars, path_reg, /GET_LUN
n_stars = N_ELEMENTS(result.x_stars)
for is = 0, n_stars-1 do begin
	printf, lu_stars, result.x_stars[is], result.y_stars[is], $
	        format='("point ",f7.1," ",f7.1," # point=diamond")
endfor
FREE_LUN, lu_stars
;
;
print, 'Done!'
end